/*
	PROforma, PROGS FOnt & Raster MAnager

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 29 September 1993
	adjusted from 14 July 1994 for simplified font handling
*/

typedef struct {
	long stack[font_stack_size];		/* font stack */
	long retstack[font_subrout_max];	/* subrout stack */
	long *currstack;					/* current pos in font stack */
	long *currretstack; 				/* current pos in subrout stack */
	char *charpos;						/* current position in charstring */
	long sbx, sby;						/* sidebearing values, for seac */
	char seac;							/* has been a seac, set CharWidth ?? */
	char contchar;						/* is interpretation of endchar real */
	coor cont;							/* for relative move in a seac */
	char *contcharpos;					/* charpos for when cont */
	short charposx, charposy;			/* current position in character space */
	hintdata *hints;					/* hints which should be used */
	font *currfont; 					/* font where character comes from */
	hintdata clienthints;				/* hints for when client calls */
	char rendering; 					/* TRUE when rendering a char */
	char draw;							/* TRUE when char has line/curve */
	short code; 						/* charcode which is being rendered */
	Gstate gstate;						/* (this->parent) */
	coor pathorg, currpos;				/* for rendering chars */
} CharPath;

/* all the coordinates returned are in either user or device coordinates,
   depending on the init routine used. All coordinates are absolute, and
   represent the character at the current size etc.
   The only exception in CharWidth, which always returns the coordinates
   in user coordinates (suitable for PFmove). */
