/*
	header file for PROforma
	definition of linked list macros

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 21 July 1993
*/

/* single linked lists */

#define linkin(el, list) \
		do { el->next=list; list=el; } while (0)

#define safelinkin(el, list) \
		do { _super(); el->next=list; list=el; _user(); } while (0)

#define linkout(el, list) \
		do { el=list; list=el->next; } while (0)

#define list_release(b) 		\
		do {                    \
			char *n;			\
			while (b)			\
			{                   \
				n=(char *)b;	\
				b=b->next;		\
				MEMRelease(n);	\
			}					\
		} while (0)
